Role('JooseX.Observable.Attribute', {
    
    override : {
        
        getSetter : function () {
            var original    = this.SUPER()
            
            // here "this" is the attribute instance
            var me          = this
            
            return function (value) {
                var prevValue       = me.getValueFrom(this) // or just this[ me.slot ] for simple cases
                
                // here - "this" is the instance of class that has this attribute
                var result  = original.apply(this, arguments)
                
                this.fireEvent(me.name + 'change', value, prevValue)
                
                return result
            }
        }
    }
})


Role('JooseX.Observable.Class', {
    does : [
        JooseX.Observable
    ],
     
    trait   : Role({
        has : {
            defaultAttributeClass       : Class({ does : JooseX.Observable.Attribute, isa : Joose.Managed.Attribute })
        }
    })
})


Class('My.Observable.Class', {
    does        : JooseX.Observable.Class,
      
    has     : {
        attribute       : {
            // to create getter/setter
            is  : 'rw' 
        }
    }
})

var instance = new My.Observable.Class({
    attribute       : 1
})


instance.on('attributechange', function (event, newValue, oldValue) { console.log("handler works, new value = " + newValue + ", old value = " + oldValue) })

instance.setAttribute(2)